<?php
/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme/db.txt .

****************************************

 :

1.0	2003.??.??  (club@shelek.com)
      . -: sql_connect, sql_query, sql_close.

2.0	2005.04.?? RXL (rxl@mail.ru)
     .  - : connect, query, disconnect.
 -: db, get_value, get_row, get_rows, get_table, esc,
array_to_list, free_result, get_insert_id.
  .

3.0	2006.02.24 RXL (rxl@mail.ru)
      db_result     -: get_value, get_row,
get_rows, free_result.    free.
 db::query     db_result.

3.1	2006.02.26 RXL (rxl@mail.ru)
      vu-3.0.0.
 - print_error   $die_level, $report_level.
- query  ,    ,  
    db::rows .

3.2	2006.03.06 RXL (rxl@mail.ru)
     - print_error   .

*/

class core__db_result
{
    var $res = false;
    var $rows = 0;
    var $cols = 0;

    function free()
    {
        if ($this->res)
	    @mysql_free_result($this->res);
        $this->res = false;
    }

    function get_value()
    {
	$r = mysql_result($this->res, 0);
	$this->free();
	return $r;
    }

    function get_row($type = MYSQL_ASSOC)
    {
        if ($row = mysql_fetch_array($this->res, $type))
	    return $row;
	$this->free();
        return false;
    }

    function get_rows($count = -1, $type = MYSQL_ASSOC)
    {
	$rows = array();
	for ($n = 0; $n == $count; $n++)
	{
	    if ($row = $this->get_row($type))
		array_push($rows, $row);
	    else
		break;
	}
	return count($rows) ? $rows : false;
    }

}

class core__db
{
    var $server = array(
	'host' => '',
	'user' => '',
	'pass' => '',
	'name' => '',
	'prefix' => ''
	);
    var $conn_id;
    var $err = '';
    var $connected = false;
    var $last_query = ''; // for debug
    var $rows = 0; // affected rows

    function core__db($to_connect = true)
    {
	$this->server = array_merge($this->server, _g('db'));
        if ($to_connect)
	    $this->connect();
	user_error('core__db::core__db(): mysql support loaded', DEBUG);
    }

    function connect()
    {
        $this->conn_id = mysql_connect($this->server['host'], $this->server['user'], $this->server['pass']);
        mysql_select_db($this->server['name']);
        $this->err = mysql_error();
    }

    function disconnect()
    {
        mysql_close($this->conn_id);
        $this->err = mysql_error();
    }

    function query($query)
    {
	$this->last_query = $query;
	$this->rows = 0;
	$res = new core__db_result;
        $res->res = mysql_query($query, $this->conn_id);
        $this->err = mysql_error();
	if ($res->res === true)
	{
	    $this->rows = mysql_affected_rows($res->res);
	    return true;
	}
	if ($res->res)
	{
	    $res->rows = mysql_num_rows($res->res);
	    $res->cols = mysql_num_fields($res->res);
	    return $res;
	}
	return false;
    }

    function get_insert_id()
    {
        return mysql_insert_id($this->conn_id);
    }

    function get_table($name)
    {
        return $this->server['prefix'] . $name;
    }

    function esc($str) // escape and quote
    {
	return '"' . mysql_escape_string($str) . '"';
    }

    function array_to_list($arr) // convert scalar's array to escaped, quoted and comma separated list
    {
        if (! is_array($arr))
	    die('FATAL: core__db::array_to_list(): wrong argument');
        if (count($arr) == 0)
	    return '';
	foreach ($arr as $k=>$v)
	{
	    if (is_numeric($v))
		$arr[$k] += 0;
	    else if (is_string($v))
		$arr[$k] = $this->esc($v);
	    else
		user_error('core__db::array_to_list(): no scalar value', ERROR);
	}
        return join(',', $arr);
    }
}

?>